/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.mammographycadsriodtemplates;

import cdac.medinfo.sdk.dcm30_04.baselibs.ContentSequenceItem;
import cdac.medinfo.sdk.dcm30_04.enums.EnumContinuityOfContent;
import cdac.medinfo.sdk.dcm30_04.srtree.SRTree;
import cdac.medinfo.sdk.dcm30_04.templates.cid.CADOperatingPointAxisLabel_CID6048;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CADOperatingPointAxisLabel;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CADOperatingPoints;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_CADOperatingPoints;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.Template;

/**
 * This class represents CADOperatingPoints_TID4023
 */
public class CADOperatingPoints_TID4023 extends Template
{
	/**
	 * Object of CADOperatingPointAxisLabel_CID6048
	 */
	private CADOperatingPointAxisLabel_CID6048 objCADOperatingPointAxisLabelCID6048;

	/**
	 * Instantiates a new HemodynamicAcquisitionContext_TID3530 Template.
	 * @param objTree Object of SRTree.
	 */
	public CADOperatingPoints_TID4023(SRTree objTree)
	{
		super(objTree);
	}

	/**
	 * Sets value for X-Concept.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumCADOperatingPointAxisLabel Enumerated value for CADOperatingPointAxisLabel.
	 * @param arrNumericValue 
	 */
	public void setXConcept(int[] arrPosition, EnumCM_CADOperatingPointAxisLabel enumCADOperatingPointAxisLabel, String[] arrNumericValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CADOperatingPoints.X_CONCEPT.getValue();
		String strCodeValue = EnumCV_CADOperatingPoints.X_CONCEPT_122698.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();

		/**
		 * Setting value for CADOperatingPointAxisLabel
		 */
		if(null== this.objCADOperatingPointAxisLabelCID6048)
			this.objCADOperatingPointAxisLabelCID6048 = new CADOperatingPointAxisLabel_CID6048();
		this.objCADOperatingPointAxisLabelCID6048.setCADOperatingPointAxisLabel(enumCADOperatingPointAxisLabel);

		String strCM = objCADOperatingPointAxisLabelCID6048.getCodeMeaning();
		String strCV = objCADOperatingPointAxisLabelCID6048.getCodeValue();
		String strCSD = objCADOperatingPointAxisLabelCID6048.getCodingSchemeDesignator();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSDesg, strCV, strCSD, "", strCM);
		getSRTree().addChild(objContentSequenceItem);
		/**
		 * Creating a node of Value Type NUM and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem1 = getSRTree().createNumNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, arrNumericValue, "", "", "", "", "", "", "", "");
		getSRTree().addChild(objContentSequenceItem1);
	}
	/**
	 * Sets value for Y-Concept.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumCADOperatingPointAxisLabel Enumerated value for CADOperatingPointAxisLabel.
	 * @param arrNumericValue 
	 */
	public void setYConcept(int[] arrPosition, EnumCM_CADOperatingPointAxisLabel enumCADOperatingPointAxisLabel, String[] arrNumericValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CADOperatingPoints.Y_CONCEPT.getValue();
		String strCodeValue = EnumCV_CADOperatingPoints.Y_CONCEPT_122699.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();

		/**
		 * Setting value for CADOperatingPointAxisLabel
		 */
		if(null== this.objCADOperatingPointAxisLabelCID6048)
			this.objCADOperatingPointAxisLabelCID6048 = new CADOperatingPointAxisLabel_CID6048();
		this.objCADOperatingPointAxisLabelCID6048.setCADOperatingPointAxisLabel(enumCADOperatingPointAxisLabel);

		String strCM = objCADOperatingPointAxisLabelCID6048.getCodeMeaning();
		String strCV = objCADOperatingPointAxisLabelCID6048.getCodeValue();
		String strCSD = objCADOperatingPointAxisLabelCID6048.getCodingSchemeDesignator();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSDesg, strCV, strCSD, "", strCM);
		getSRTree().addChild(objContentSequenceItem);
		/**
		 * Creating a node of Value Type NUM and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem1 = getSRTree().createNumNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, arrNumericValue, "", "", "", "", "", "", "", "");
		getSRTree().addChild(objContentSequenceItem1);
	}


	/**
	 * Sets Source of CAD Operating Point.
	 * @param arrPosition position at which the node will get added in the tree.
	 * @param arrNumericValue 
	 */
	public void setCADOperatingPoint(int[] arrPosition, String[] arrNumericValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CADOperatingPoints.CAD_OPERATING_POINT.getValue();
		String strCodeValue = EnumCV_CADOperatingPoints.CAD_OPERATING_POINT_111071.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type NUM and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, arrNumericValue, "", "", "", "", "", "", "", "");
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets Source of CAD Operating Point Description.
	 * @param arrPosition position at which node is to be added in the tree.
	 * @param strValue 
	 */
	public void setCADOperatingPointDescription(int[] arrPosition, String strValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CADOperatingPoints.CAD_OPERATING_POINTS_DESCRIPTION.getValue();
		String strCodeValue = EnumCV_CADOperatingPoints.CAD_OPERATING_POINTS_DESCRIPTION_111081.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type TEXT and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createTextNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strValue);
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets Source of CAD Operating Point Table.
	 * @param arrPosition position at which node is to be added in the tree.
	 * @param strValue 
	 * @param enumContinuityOfContent 
	 */
	public void setCADOperatingPointTable(int[] arrPosition, EnumContinuityOfContent enumContinuityOfContent)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CADOperatingPoints.CAD_OPERATING_POINT_TABLE.getValue();
		String strCodeValue = EnumCV_CADOperatingPoints.CAD_OPERATING_POINT_TABLE_111093.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type CONTAINER and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createContainer(arrPosition, strCodeMeaning, strCodeValue, strCSD, enumContinuityOfContent);
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets Source of Recommended CAD Operating Point.
	 * @param arrPosition position at which node is to be added in the tree.
	 * @param arrNumericValue 
	 */
	public void setRecommendedCADOperatingPoint(int[] arrPosition, String[] arrNumericValue )
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CADOperatingPoints.RECOMMENDED_CAD_OPERATING_POINT.getValue();
		String strCodeValue = EnumCV_CADOperatingPoints.RECOMMENDED_CAD_OPERATING_POINT_111092.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type NUM and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, arrNumericValue, "", "", "", "", "", "", "", "");
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets Source of Maximum CAD Operating Point.
	 * @param arrPosition position at which node is to be added in the tree.
	 * @param arrNumericValue 
	 */
	public void setMaximumCADOperatingPoint(int[] arrPosition, String[] arrNumericValue )
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CADOperatingPoints.MAXIMUM_CAD_OPERATING_POINT.getValue();
		String strCodeValue = EnumCV_CADOperatingPoints.MAXIMUM_CAD_OPERATING_POINT_111072.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type NUM and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, arrNumericValue, "", "", "", "", "", "", "", "");
		getSRTree().addChild(objContentSequenceItem);
	}
}

